/* Bull Run Performance Curves
   Dudley J. Benton */

#define _CRT_SECURE_NO_DEPRECATE
#include <stdio.h>
#include <float.h>
#define _USE_MATH_DEFINES
#include <math.h>

double BPCF(double TFR,double BP)
  {
  return(-0.0977985024+(0.05223989068+0.032216412*TFR)*TFR
    +(0.07015588968-0.05442938242*TFR-0.0002724334116*BP)*BP);
  }

double DPCF(double TFR,double DPR)
  {
  return(0.4502222916+(-0.4195020537-0.02837355713*DPR)*DPR
    +(0.4689495632*DPR-0.4746858062+0.0027128048*TFR)*TFR);
  }

double IPCF(double TFR,double PMS)
  {
  return(-0.3029272533+(0.2185089615+0.08500671427*PMS)*PMS
    +(-0.41821944*PMS+0.4128875776+0.005598944*TFR)*TFR);
  }

double TMCF(double TFR,double DTM)
  {
  return(-0.001414010857+(-0.00031465193+0.2056790714E-6*DTM)*DTM
    +(0.000123069752*DTM+0.0033488252-0.001493736*TFR)*TFR);
  }

double TRCF(double TFR,double DTR)
  {
  return(0.0002841277143+(-0.00020999653+0.7978571429E-9*DTR)*DTR
    +(0.000094114048*DTR-0.0011594192+0.000889376*TFR)*TFR);
  }

double LOCF(double HRCF(double,double),double X,double Y)
  {
  double CF;
  CF=HRCF(X,Y);
  return(-CF/(1.+CF));
  }

int main(int argc,char**argv,char**envp)
  {
  double BP,TFR;
  printf("Bull Run Performance Curves\n");
  printf("    <------- heat rate -------> <--------- load --------->\n");
  printf(" BP  0.25   0.50   0.50   1.00   0.25   0.50   0.75   1.00\n");
  for(BP=0.5;BP<5.01;BP+=0.1)
    {
    printf("%3.1lf",BP);
    for(TFR=0.25;TFR<1.01;TFR+=0.25)
      printf(" %6.3lf",BPCF(TFR,BP));
    for(TFR=0.25;TFR<1.01;TFR+=0.25)
      printf(" %6.3lf",LOCF(BPCF,TFR,BP));
    printf("\n");
    }
  return(0);
  }
