/* cloud cover simulation
   developed by
   dudley.benton@gmail.com
*/
#define _CRT_SECURE_NO_DEPRECATE
#include <stdio.h>
#include <stddef.h>
#include <stdarg.h>
#include <stdlib.h>
#include <malloc.h>
#include <float.h>
#define _USE_MATH_DEFINES
#include <math.h>
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include "..\\bitmap\\bitmap.h"
#include "..\\bitmap\\gif89a.h"

int main(int argc,char**argv,char**envp)
  {
  char*fname="clouds.gif";
  int h,i,j,k,w,wide8,wide24;
  BITMAPINFOHEADER*bm,*Collectors,*Shading;
  BYTE b,*collectors,*bits,g,r,shade,*shading;
  DWORD*palette;
  GIFX gif;
  Collectors=BMPread("collectors.bmp");
  collectors=BMPbits(Collectors);
  wide24=BMPwidth(Collectors->biWidth,Collectors->biBitCount);
  Shading=BMPread("shading.bmp");
  palette=BMPpalette(Shading);
  shading=BMPbits(Shading);
  wide8=BMPwidth(Shading->biWidth,Shading->biBitCount);
  bm=BMPduplicate(Collectors);
  bits=BMPbits(bm);
  memset(&gif,0,sizeof(gif));
  gif.frames=64;
  gif.delay=50;
  gif.bm=calloc(gif.frames,sizeof(BITMAPINFOHEADER*));
  for(k=0;k<gif.frames;k++)
    {
    printf("\r%i",k+1);
    for(h=0;h<bm->biHeight;h++)
      {
      for(w=0;w<bm->biWidth;w++)
        {
        i=wide8*((h+4*k)%Shading->biHeight)+(w+4*k)%Shading->biWidth;
        j=shading[i];
        shade=(2500*((int)RedRGB(palette[j])))/3014;
        j=wide24*h+3*w;
        r=collectors[j];
        g=collectors[j+1];
        b=collectors[j+2];
        r=(((WORD)r)*((WORD)shade))/255;
        g=(((WORD)g)*((WORD)shade))/255;
        b=(((WORD)b)*((WORD)shade))/255;
        bits[j]=r;
        bits[j+1]=g;
        bits[j+2]=b;
        }
      }
    gif.bm[k]=BMPduplicate(bm);
    }
  printf("\r%s\n",fname);
  WriteGIF(gif,fname);
  for(k=h=0;h<bm->biHeight;h++)
    {
    for(w=0;w<bm->biWidth;w++)
      {
      i=wide8*((h+4*k)%Shading->biHeight)+(w+4*k)%Shading->biWidth;
      j=shading[i];
      shade=(2500*((int)RedRGB(palette[j])))/3014;
      k+=shade;
      }
    }
  printf("shading=%.0lf%%\n",k/255./Shading->biHeight*100./Shading->biWidth);
  return(0);
  }
  